diff -pruN 13.2.0-20/debian/changelog 13.2.0-21/debian/changelog
--- 13.2.0-20/debian/changelog	2024-03-23 10:38:07.000000000 +0000
+++ 13.2.0-21/debian/changelog	2024-03-24 13:49:13.000000000 +0000
@@ -1,3 +1,13 @@
+gcc-13 (13.2.0-21) unstable; urgency=medium
+
+  * Update to git 20240324 from the gcc-13 branch.
+    - Fix PR fortran/101135, PR fortran/55978.
+  * Update the proposed patch to fix PR ada/114064.
+  * Move the _FORTIFY_SOURCE setting from cc1 to the driver.
+  * Refresh patches.
+
+ -- Matthias Klose <doko@debian.org>  Sun, 24 Mar 2024 14:49:13 +0100
+
 gcc-13 (13.2.0-20) unstable; urgency=medium
 
   * Update to git 20240323 from the gcc-13 branch.
diff -pruN 13.2.0-20/debian/patches/ada-armel-libatomic.diff 13.2.0-21/debian/patches/ada-armel-libatomic.diff
--- 13.2.0-20/debian/patches/ada-armel-libatomic.diff	2024-01-23 20:59:29.000000000 +0000
+++ 13.2.0-21/debian/patches/ada-armel-libatomic.diff	2024-03-24 13:49:13.000000000 +0000
@@ -13,7 +13,7 @@ Author: Nicolas Boulenguez <nicolas@debi
 
 --- a/src/gcc/ada/Makefile.rtl
 +++ b/src/gcc/ada/Makefile.rtl
-@@ -2211,6 +2211,7 @@ endif
+@@ -2213,6 +2213,7 @@ endif
  
  # ARM linux, GNU eabi
  ifeq ($(strip $(filter-out arm% linux-gnueabi%,$(target_cpu) $(target_os))),)
@@ -23,7 +23,7 @@ Author: Nicolas Boulenguez <nicolas@debi
    s-inmaop.adb<libgnarl/s-inmaop__posix.adb \
 --- a/src/Makefile.def
 +++ b/src/Makefile.def
-@@ -396,6 +396,8 @@ dependencies = { module=all-target-libad
+@@ -397,6 +397,8 @@ dependencies = { module=all-target-libad
  dependencies = { module=all-gnattools; on=all-target-libada; };
  dependencies = { module=all-gnattools; on=all-target-libstdc++-v3; };
  
diff -pruN 13.2.0-20/debian/patches/ada-link-lib.diff 13.2.0-21/debian/patches/ada-link-lib.diff
--- 13.2.0-20/debian/patches/ada-link-lib.diff	2024-01-23 20:59:29.000000000 +0000
+++ 13.2.0-21/debian/patches/ada-link-lib.diff	2024-03-24 13:49:13.000000000 +0000
@@ -75,7 +75,7 @@ Author: Matthias Klose <doko@debian.org>
          "PICFLAG_FOR_TARGET=$(PICFLAG)" \
 --- a/src/Makefile.def
 +++ b/src/Makefile.def
-@@ -392,6 +392,7 @@ dependencies = { module=all-libcpp; on=a
+@@ -393,6 +393,7 @@ dependencies = { module=all-libcpp; on=a
  
  dependencies = { module=all-fixincludes; on=all-libiberty; };
  
diff -pruN 13.2.0-20/debian/patches/gcc-as-needed.diff 13.2.0-21/debian/patches/gcc-as-needed.diff
--- 13.2.0-20/debian/patches/gcc-as-needed.diff	2024-01-23 20:59:29.000000000 +0000
+++ 13.2.0-21/debian/patches/gcc-as-needed.diff	2024-03-24 13:49:13.000000000 +0000
@@ -254,7 +254,7 @@
      %{!static: \
 --- a/src/gcc/config/loongarch/gnu-user.h
 +++ b/src/gcc/config/loongarch/gnu-user.h
-@@ -40,6 +40,7 @@ along with GCC; see the file COPYING3.  If not see
+@@ -45,6 +45,7 @@ along with GCC; see the file COPYING3.
  #undef GNU_USER_TARGET_LINK_SPEC
  #define GNU_USER_TARGET_LINK_SPEC \
    "%{G*} %{shared} -m " GNU_USER_LINK_EMULATION \
diff -pruN 13.2.0-20/debian/patches/gcc-auto-build.diff 13.2.0-21/debian/patches/gcc-auto-build.diff
--- 13.2.0-20/debian/patches/gcc-auto-build.diff	2024-01-23 20:59:29.000000000 +0000
+++ 13.2.0-21/debian/patches/gcc-auto-build.diff	2024-03-24 13:49:13.000000000 +0000
@@ -1,10 +1,8 @@
 # DP: Fix cross building a native compiler.
 
-Index: b/src/gcc/configure.ac
-===================================================================
 --- a/src/gcc/configure.ac
 +++ b/src/gcc/configure.ac
-@@ -2115,7 +2115,7 @@ else
+@@ -2132,7 +2132,7 @@ else
  	# Clearing GMPINC is necessary to prevent host headers being
  	# used by the build compiler.  Defining GENERATOR_FILE stops
  	# system.h from including gmp.h.
diff -pruN 13.2.0-20/debian/patches/gcc-distro-specs.diff 13.2.0-21/debian/patches/gcc-distro-specs.diff
--- 13.2.0-20/debian/patches/gcc-distro-specs.diff	2024-02-21 01:12:23.000000000 +0000
+++ 13.2.0-21/debian/patches/gcc-distro-specs.diff	2024-03-24 13:29:03.000000000 +0000
@@ -14,7 +14,7 @@
  #define INCLUDE_STRING
  #include "config.h"
  #include "system.h"
-@@ -971,6 +976,104 @@ proper position among the other output f
+@@ -971,6 +976,113 @@ proper position among the other output f
  #define LINK_GCC_C_SEQUENCE_SPEC "%G %{!nolibc:%L %G}"
  #endif
  
@@ -81,6 +81,15 @@
 +# endif
 +#endif
 +
++/* Enable -D_FORTIFY_SOURCE=    */
++#ifndef FORTIFY_SOURCE_SPEC
++# ifdef DIST_DEFAULT_FORTIFY_SOURCE
++#  define FORTIFY_SOURCE_SPEC " %{!O0:%{O*:%{!D_FORTIFY_SOURCE=*:%{!U_FORTIFY_SOURCE:-D_FORTIFY_SOURCE=" DIST_DEFAULT_FORTIFY_SOURCE_S "}}}}"
++# else
++#  define FORTIFY_SOURCE_SPEC ""
++# endif
++#endif
++
 +#ifndef BIND_NOW_SPEC
 +# if defined(DIST_DEFAULT_BIND_NOW) && !defined(ACCEL_COMPILER)
 +#  define BIND_NOW_SPEC " -z now"
@@ -100,7 +109,7 @@
 +/* Don't enable any of those for the offload compilers,
 +   unsupported.  */
 +#if !defined(DISTRO_DEFAULT_CPP_SPEC) && !defined(ACCEL_COMPILER)
-+# define DISTRO_DEFAULT_CPP_SPEC TIMET64_SPEC
++# define DISTRO_DEFAULT_CPP_SPEC TIMET64_SPEC FORTIFY_SOURCE_SPEC
 +#else
 +# define DISTRO_DEFAULT_CPP_SPEC ""
 +#endif
@@ -119,7 +128,7 @@
  #ifndef LINK_SSP_SPEC
  #ifdef TARGET_LIBC_PROVIDES_SSP
  #define LINK_SSP_SPEC "%{fstack-protector|fstack-protector-all" \
-@@ -1027,7 +1130,7 @@ proper position among the other output f
+@@ -1027,7 +1139,7 @@ proper position among the other output f
  #ifndef LINK_PIE_SPEC
  #ifdef HAVE_LD_PIE
  #ifndef LD_PIE_SPEC
@@ -128,7 +137,7 @@
  #endif
  #else
  #define LD_PIE_SPEC ""
-@@ -1144,6 +1247,7 @@ proper position among the other output f
+@@ -1144,6 +1256,7 @@ proper position among the other output f
     "%{flto|flto=*:%<fcompare-debug*} \
      %{flto} %{fno-lto} %{flto=*} %l " LINK_PIE_SPEC \
     "%{fuse-ld=*:-fuse-ld=%*} " LINK_COMPRESS_DEBUG_SPEC \
@@ -136,7 +145,7 @@
     "%X %{o*} %{e*} %{N} %{n} %{r}\
      %{s} %{t} %{u*} %{z} %{Z} %{!nostdlib:%{!r:%{!nostartfiles:%S}}} \
      %{static|no-pie|static-pie:} %@{L*} %(mfwrap) %(link_libgcc) " \
-@@ -1184,6 +1288,8 @@ static const char *cpp_spec = CPP_SPEC;
+@@ -1184,6 +1297,8 @@ static const char *cpp_spec = CPP_SPEC;
  static const char *cc1_spec = CC1_SPEC OS_CC1_SPEC;
  static const char *cc1plus_spec = CC1PLUS_SPEC;
  static const char *link_gcc_c_sequence_spec = LINK_GCC_C_SEQUENCE_SPEC;
@@ -145,7 +154,7 @@
  static const char *link_ssp_spec = LINK_SSP_SPEC;
  static const char *asm_spec = ASM_SPEC;
  static const char *asm_final_spec = ASM_FINAL_SPEC;
-@@ -1242,7 +1348,7 @@ static const char *cpp_options =
+@@ -1242,7 +1357,7 @@ static const char *cpp_options =
  "%(cpp_unique_options) %1 %{m*} %{std*&ansi&trigraphs} %{W*&pedantic*} %{w}\
   %{f*} %{g*:%{%:debug-level-gt(0):%{g*}\
   %{!fno-working-directory:-fworking-directory}}} %{O*}\
@@ -154,7 +163,7 @@
  
  /* Pass -d* flags, possibly modifying -dumpdir, -dumpbase et al.
  
-@@ -1436,9 +1542,9 @@ static const struct compiler default_com
+@@ -1436,9 +1551,9 @@ static const struct compiler default_com
        %{save-temps*|traditional-cpp|no-integrated-cpp:%(trad_capable_cpp) \
  	  %(cpp_options) -o %{save-temps*:%b.i} %{!save-temps*:%g.i} \n\
  	    cc1 -fpreprocessed %{save-temps*:%b.i} %{!save-temps*:%g.i} \
@@ -166,7 +175,7 @@
        %{!fsyntax-only:%(invoke_as)}}}}", 0, 0, 1},
    {"-",
     "%{!E:%e-E or -x required when input is from standard input}\
-@@ -1452,18 +1558,18 @@ static const struct compiler default_com
+@@ -1452,18 +1567,18 @@ static const struct compiler default_com
  	  %{save-temps*|traditional-cpp|no-integrated-cpp:%(trad_capable_cpp) \
  		%(cpp_options) -o %{save-temps*:%b.i} %{!save-temps*:%g.i} \n\
  		    cc1 -fpreprocessed %{save-temps*:%b.i} %{!save-temps*:%g.i} \
@@ -188,7 +197,7 @@
    {".s", "@assembler", 0, 0, 0},
    {"@assembler",
     "%{!M:%{!MM:%{!E:%{!S:as %(asm_debug) %(asm_options) %i %A }}}}", 0, 0, 0},
-@@ -1695,6 +1801,8 @@ static struct spec_list static_specs[] =
+@@ -1695,6 +1810,8 @@ static struct spec_list static_specs[] =
    INIT_STATIC_SPEC ("cc1_options",		&cc1_options),
    INIT_STATIC_SPEC ("cc1plus",			&cc1plus_spec),
    INIT_STATIC_SPEC ("link_gcc_c_sequence",	&link_gcc_c_sequence_spec),
@@ -310,33 +319,3 @@
 -    cc1objplus -fpreprocessed %i %(cc1_options) %2\
 +    cc1objplus -fpreprocessed %i %(distro_defaults_cpp) %(cc1_options) %(distro_defaults) %2\
      %{!fsyntax-only:%(invoke_as)}}}}", 0, 0, 0},
---- a/src/gcc/c-family/c-cppbuiltin.cc
-+++ b/src/gcc/c-family/c-cppbuiltin.cc
-@@ -34,6 +34,11 @@ along with GCC; see the file COPYING3.
- #include "cppbuiltin.h"
- #include "configargs.h"
- 
-+/* Inject some default compilation flags which are used as the default.
-+   Done by the packaging build system.  Should that be done in the headers
-+   in gcc/config/<arch>/ instead?  */
-+#include "distro-defaults.h"
-+
- #ifndef TARGET_OS_CPP_BUILTINS
- # define TARGET_OS_CPP_BUILTINS()
- #endif
-@@ -1546,6 +1551,15 @@ c_cpp_builtins (cpp_reader *pfile)
-   builtin_define_with_value ("__REGISTER_PREFIX__", REGISTER_PREFIX, 0);
-   builtin_define_with_value ("__USER_LABEL_PREFIX__", user_label_prefix, 0);
- 
-+#ifdef DIST_DEFAULT_FORTIFY_SOURCE
-+  /* Fortify Source enabled by default for optimization levels > 0 */
-+  if (optimize &&
-+      !cpp_defined(parse_in,
-+		   (const unsigned char *) "_FORTIFY_SOURCE",
-+		   strlen("_FORTIFY_SOURCE")))
-+    builtin_define_with_int_value ("_FORTIFY_SOURCE", DIST_DEFAULT_FORTIFY_SOURCE);
-+#endif
-+
-   /* Misc.  */
-   if (flag_gnu89_inline)
-     cpp_define (pfile, "__GNUC_GNU_INLINE__");
diff -pruN 13.2.0-20/debian/patches/gcc-force-cross-layout.diff 13.2.0-21/debian/patches/gcc-force-cross-layout.diff
--- 13.2.0-20/debian/patches/gcc-force-cross-layout.diff	2024-01-23 20:59:29.000000000 +0000
+++ 13.2.0-21/debian/patches/gcc-force-cross-layout.diff	2024-03-24 13:49:13.000000000 +0000
@@ -1,7 +1,5 @@
 # DP: Add FORCE_CROSS_LAYOUT env var to force a cross directory layout.
 
-Index: b/src/configure.ac
-===================================================================
 --- a/src/configure.ac
 +++ b/src/configure.ac
 @@ -3302,7 +3302,7 @@ target_configargs="$target_configargs ${
@@ -13,11 +11,9 @@ Index: b/src/configure.ac
    target_configargs="--with-cross-host=${host_noncanonical} ${target_configargs}"
  fi
  
-Index: b/src/gcc/configure.ac
-===================================================================
 --- a/src/gcc/configure.ac
 +++ b/src/gcc/configure.ac
-@@ -2457,14 +2457,14 @@ SYSTEM_HEADER_DIR='$(NATIVE_SYSTEM_HEADE
+@@ -2474,14 +2474,14 @@ SYSTEM_HEADER_DIR='$(NATIVE_SYSTEM_HEADE
  BUILD_SYSTEM_HEADER_DIR=$SYSTEM_HEADER_DIR	AC_SUBST(BUILD_SYSTEM_HEADER_DIR)
  
  if test x$host != x$target || test "x$TARGET_SYSTEM_ROOT" != x ||
@@ -34,7 +30,7 @@ Index: b/src/gcc/configure.ac
    then
      CROSS="-DCROSS_DIRECTORY_STRUCTURE"
      ALL=all.cross
-@@ -7364,14 +7364,14 @@ AC_SUBST_FILE(language_hooks)
+@@ -7412,14 +7412,14 @@ AC_SUBST_FILE(language_hooks)
  
  # Echo link setup.
  if test x${build} = x${host} ; then
diff -pruN 13.2.0-20/debian/patches/gcc-ice-apport.diff 13.2.0-21/debian/patches/gcc-ice-apport.diff
--- 13.2.0-20/debian/patches/gcc-ice-apport.diff	2024-01-23 20:59:29.000000000 +0000
+++ 13.2.0-21/debian/patches/gcc-ice-apport.diff	2024-03-24 13:49:13.000000000 +0000
@@ -3,7 +3,7 @@
 
 --- a/src/gcc/gcc.cc
 +++ b/src/gcc/gcc.cc
-@@ -7935,13 +7935,16 @@ do_report_bug (const char **new_argv, const int nargs,
+@@ -7965,13 +7965,16 @@ do_report_bug (const char **new_argv, co
    if (status == ATTEMPT_STATUS_SUCCESS)
      {
        const bool gcc_dump = has_deb_build_options ("gcc-ice", "nodump");
@@ -21,7 +21,7 @@
  	{
  	  char *cmd = XNEWVEC (char, 50 + strlen (*out_file));
  
-@@ -7955,6 +7958,15 @@ do_report_bug (const char **new_argv, const int nargs,
+@@ -7985,6 +7988,15 @@ do_report_bug (const char **new_argv, co
  	  fflush (stderr);
  	  free (cmd);
  	}
diff -pruN 13.2.0-20/debian/patches/gcc-ice-dump.diff 13.2.0-21/debian/patches/gcc-ice-dump.diff
--- 13.2.0-20/debian/patches/gcc-ice-dump.diff	2024-01-23 20:59:29.000000000 +0000
+++ 13.2.0-21/debian/patches/gcc-ice-dump.diff	2024-03-24 13:49:13.000000000 +0000
@@ -3,7 +3,7 @@
 
 --- a/src/gcc/gcc.cc
 +++ b/src/gcc/gcc.cc
-@@ -3108,6 +3108,61 @@ access_check (const char *name, int mode)
+@@ -3122,6 +3122,61 @@ access_check (const char *name, int mode
    return access (name, mode);
  }
  
@@ -65,7 +65,7 @@
  /* Callback for find_a_file.  Appends the file name to the directory
     path.  If the resulting file exists in the right mode, return the
     full pathname to the file.  */
-@@ -3634,9 +3673,10 @@ execute (void)
+@@ -3648,9 +3703,10 @@ execute (void)
  	    /* For ICEs in cc1, cc1obj, cc1plus see if it is
  	       reproducible or not.  */
  	    const char *p;
@@ -79,7 +79,7 @@
  		&& (p = strrchr (commands[0].argv[0], DIR_SEPARATOR))
  		&& startswith (p + 1, "cc1"))
  	      try_generate_repro (commands[0].argv);
-@@ -7894,8 +7934,27 @@ do_report_bug (const char **new_argv, const int nargs,
+@@ -7908,8 +7964,27 @@ do_report_bug (const char **new_argv, co
  
    if (status == ATTEMPT_STATUS_SUCCESS)
      {
diff -pruN 13.2.0-20/debian/patches/gcc-search-prefixed-as-ld.diff 13.2.0-21/debian/patches/gcc-search-prefixed-as-ld.diff
--- 13.2.0-20/debian/patches/gcc-search-prefixed-as-ld.diff	2024-01-23 20:59:29.000000000 +0000
+++ 13.2.0-21/debian/patches/gcc-search-prefixed-as-ld.diff	2024-03-24 13:49:13.000000000 +0000
@@ -2,7 +2,7 @@
 
 --- a/src/gcc/gcc.cc
 +++ b/src/gcc/gcc.cc
-@@ -2894,6 +2894,7 @@ for_each_path (const struct path_prefix
+@@ -2919,6 +2919,7 @@ for_each_path (const struct path_prefix
  	{
  	  len = paths->max_len + extra_space + 1;
  	  len += MAX (MAX (suffix_len, multi_os_dir_len), multiarch_len);
@@ -10,7 +10,7 @@
  	  path = XNEWVEC (char, len);
  	}
  
-@@ -3107,6 +3108,24 @@ file_at_path (char *path, void *data)
+@@ -3132,6 +3133,24 @@ file_at_path (char *path, void *data)
    struct file_at_path_info *info = (struct file_at_path_info *) data;
    size_t len = strlen (path);
  
diff -pruN 13.2.0-20/debian/patches/git-doc-updates.diff 13.2.0-21/debian/patches/git-doc-updates.diff
--- 13.2.0-20/debian/patches/git-doc-updates.diff	2024-03-23 10:31:02.000000000 +0000
+++ 13.2.0-21/debian/patches/git-doc-updates.diff	2024-03-24 11:42:37.000000000 +0000
@@ -1,7 +1,7 @@
-# DP: updates from the 13 branch upto 20240323 (documentation).
+# DP: updates from the 13 branch upto 20240324 (documentation).
 
 LANG=C git diff --no-renames --src-prefix=a/src/ --dst-prefix=b/src/ \
-	c891d8dc23e1a46ad9f3e757d09e57b500d40044 3c9e486f9248dd3c778d5e1a902727c8e53b226f \
+	c891d8dc23e1a46ad9f3e757d09e57b500d40044 2012d1a6949b25a4656be95b35716bd423155a3d \
 	| awk '/^diff .*\.texi/ {skip=0; print; next} /^diff / {skip=1; next} skip==0' \
         | grep -v -E '^(diff|index)'
 
diff -pruN 13.2.0-20/debian/patches/git-updates.diff 13.2.0-21/debian/patches/git-updates.diff
--- 13.2.0-20/debian/patches/git-updates.diff	2024-03-23 10:31:29.000000000 +0000
+++ 13.2.0-21/debian/patches/git-updates.diff	2024-03-24 11:43:12.000000000 +0000
@@ -1,7 +1,7 @@
-# DP: updates from the 13 branch upto 20240323 (3c9e486f924).
+# DP: updates from the 13 branch upto 20240324 (2012d1a6949).
 
 LANG=C git diff --no-renames --src-prefix=a/src/ --dst-prefix=b/src/ \
-	c891d8dc23e1a46ad9f3e757d09e57b500d40044 3c9e486f9248dd3c778d5e1a902727c8e53b226f \
+	c891d8dc23e1a46ad9f3e757d09e57b500d40044 2012d1a6949b25a4656be95b35716bd423155a3d \
 	| awk '/^diff .*\.texi/ {skip=1; next} /^diff / { skip=0 } skip==0' \
 	| grep -v -E '^(diff|index)'
 
@@ -2329,7 +2329,7 @@ LANG=C git diff --no-renames --src-prefi
 +++ b/src/gcc/DATESTAMP
 @@ -1 +1 @@
 -20230727
-+20240323
++20240324
 --- a/src/gcc/ada/ChangeLog
 +++ b/src/gcc/ada/ChangeLog
 @@ -1,3 +1,599 @@
@@ -16301,7 +16301,24 @@ LANG=C git diff --no-renames --src-prefi
  	  op1 = gimple_assign_rhs1 (stmt);
 --- a/src/gcc/fortran/ChangeLog
 +++ b/src/gcc/fortran/ChangeLog
-@@ -1,3 +1,249 @@
+@@ -1,3 +1,266 @@
++2024-03-23  Harald Anlauf  <anlauf@gmx.de>
++
++	PR fortran/101135
++	* trans-array.cc (gfc_get_dataptr_offset): Check for optional
++	arguments being present before dereferencing data pointer.
++
++2024-03-23  Harald Anlauf  <anlauf@gmx.de>
++
++	PR fortran/55978
++	* interface.cc (gfc_compare_actual_formal): Skip size check for
++	NULL() actual without MOLD argument.
++
++2024-03-23  Harald Anlauf  <anlauf@gmx.de>
++
++	* trans-types.cc (gfc_get_nodesc_array_type): Clear used gmp
++	variables.
++
 +2024-03-19  Harald Anlauf  <anlauf@gmx.de>
 +
 +	Backported from master:
@@ -16795,6 +16812,17 @@ LANG=C git diff --no-renames --src-prefi
        if (a->expr->expr_type == EXPR_NULL
  	  && ((f->sym->ts.type != BT_CLASS && !f->sym->attr.pointer
  	       && (f->sym->attr.allocatable || !f->sym->attr.optional
+@@ -3362,6 +3392,10 @@ gfc_compare_actual_formal (gfc_actual_arglist **ap, gfc_formal_arglist *formal,
+       if (f->sym->ts.type == BT_CLASS)
+ 	goto skip_size_check;
+ 
++      /* Skip size check for NULL() actual without MOLD argument.  */
++      if (a->expr->expr_type == EXPR_NULL && a->expr->ts.type == BT_UNKNOWN)
++	goto skip_size_check;
++
+       actual_size = get_expr_storage_size (a->expr);
+       formal_size = get_sym_storage_size (f->sym);
+       if (actual_size != 0 && actual_size < formal_size
 --- a/src/gcc/fortran/match.cc
 +++ b/src/gcc/fortran/match.cc
 @@ -5062,6 +5062,7 @@ gfc_match_call (void)
@@ -17065,7 +17093,25 @@ LANG=C git diff --no-renames --src-prefi
      decl = sym->backend_decl;
  
    cst_offset = offset = gfc_index_zero_node;
-@@ -9200,6 +9203,12 @@ structure_alloc_comps (gfc_symbol * der_type, tree decl, tree dest,
+@@ -7323,6 +7326,17 @@ gfc_get_dataptr_offset (stmtblock_t *block, tree parm, tree desc, tree offset,
+ 
+   /* Set the target data pointer.  */
+   offset = gfc_build_addr_expr (gfc_array_dataptr_type (desc), tmp);
++
++  /* Check for optional dummy argument being present.  Arguments of BIND(C)
++     procedures are excepted here since they are handled differently.  */
++  if (expr->expr_type == EXPR_VARIABLE
++      && expr->symtree->n.sym->attr.dummy
++      && expr->symtree->n.sym->attr.optional
++      && !is_CFI_desc (NULL, expr))
++    offset = build3_loc (input_location, COND_EXPR, TREE_TYPE (offset),
++			 gfc_conv_expr_present (expr->symtree->n.sym), offset,
++			 fold_convert (TREE_TYPE (offset), gfc_index_zero_node));
++
+   gfc_conv_descriptor_data_set (block, parm, offset);
+ }
+ 
+@@ -9200,6 +9214,12 @@ structure_alloc_comps (gfc_symbol * der_type, tree decl, tree dest,
        gfc_add_expr_to_block (&fnblock, tmp);
      }
  
@@ -17078,7 +17124,7 @@ LANG=C git diff --no-renames --src-prefi
    /* Otherwise, act on the components or recursively call self to
       act on a chain of components.  */
    for (c = der_type->components; c; c = c->next)
-@@ -11278,6 +11287,15 @@ gfc_trans_deferred_array (gfc_symbol * sym, gfc_wrapped_block * block)
+@@ -11278,6 +11298,15 @@ gfc_trans_deferred_array (gfc_symbol * sym, gfc_wrapped_block * block)
      {
        gfc_conv_string_length (sym->ts.u.cl, NULL, &init);
        gfc_trans_vla_type_sizes (sym, &init);
@@ -17094,7 +17140,7 @@ LANG=C git diff --no-renames --src-prefi
      }
  
    /* Dummy, use associated and result variables don't need anything special.  */
-@@ -11387,7 +11405,11 @@ gfc_trans_deferred_array (gfc_symbol * sym, gfc_wrapped_block * block)
+@@ -11387,7 +11416,11 @@ gfc_trans_deferred_array (gfc_symbol * sym, gfc_wrapped_block * block)
      {
        int rank;
        rank = sym->as ? sym->as->rank : 0;
@@ -17107,7 +17153,7 @@ LANG=C git diff --no-renames --src-prefi
        gfc_add_expr_to_block (&cleanup, tmp);
      }
  
-@@ -11401,9 +11423,11 @@ gfc_trans_deferred_array (gfc_symbol * sym, gfc_wrapped_block * block)
+@@ -11401,9 +11434,11 @@ gfc_trans_deferred_array (gfc_symbol * sym, gfc_wrapped_block * block)
  					NULL_TREE, NULL_TREE, true, e,
  					sym->attr.codimension
  					? GFC_CAF_COARRAY_DEREGISTER
@@ -17297,7 +17343,40 @@ LANG=C git diff --no-renames --src-prefi
  	  || code->expr3->expr_type == EXPR_CONSTANT)
 --- a/src/gcc/fortran/trans-types.cc
 +++ b/src/gcc/fortran/trans-types.cc
-@@ -2324,8 +2324,8 @@ gfc_sym_type (gfc_symbol * sym, bool is_bind_c)
+@@ -1791,7 +1791,7 @@ gfc_get_nodesc_array_type (tree etype, gfc_array_spec * as, gfc_packed packed,
+ 	  TYPE_LANG_SPECIFIC (type) = TYPE_LANG_SPECIFIC (TREE_TYPE (type));
+ 	}
+ 
+-      return type;
++      goto array_type_done;
+     }
+ 
+   if (known_stride)
+@@ -1810,10 +1810,6 @@ gfc_get_nodesc_array_type (tree etype, gfc_array_spec * as, gfc_packed packed,
+ 
+   layout_type (type);
+ 
+-  mpz_clear (offset);
+-  mpz_clear (stride);
+-  mpz_clear (delta);
+-
+   /* Represent packed arrays as multi-dimensional if they have rank >
+      1 and with proper bounds, instead of flat arrays.  This makes for
+      better debug info.  */
+@@ -1844,6 +1840,12 @@ gfc_get_nodesc_array_type (tree etype, gfc_array_spec * as, gfc_packed packed,
+       GFC_ARRAY_TYPE_P (type) = 1;
+       TYPE_LANG_SPECIFIC (type) = TYPE_LANG_SPECIFIC (TREE_TYPE (type));
+     }
++
++array_type_done:
++  mpz_clear (offset);
++  mpz_clear (stride);
++  mpz_clear (delta);
++
+   return type;
+ }
+ 
+@@ -2324,8 +2326,8 @@ gfc_sym_type (gfc_symbol * sym, bool is_bind_c)
    else
      byref = 0;
  
@@ -17308,7 +17387,7 @@ LANG=C git diff --no-renames --src-prefi
    if (!restricted)
      type = gfc_nonrestricted_type (type);
  
-@@ -2381,11 +2381,10 @@ gfc_sym_type (gfc_symbol * sym, bool is_bind_c)
+@@ -2381,11 +2383,10 @@ gfc_sym_type (gfc_symbol * sym, bool is_bind_c)
  	  || (sym->ns->proc_name && sym->ns->proc_name->attr.entry_master))
  	type = build_pointer_type (type);
        else
@@ -416951,7 +417030,18 @@ new file mode 100644
        if ((GET_CODE (op) == FLOAT || GET_CODE (op) == UNSIGNED_FLOAT)
 --- a/src/gcc/testsuite/ChangeLog
 +++ b/src/gcc/testsuite/ChangeLog
-@@ -1,3 +1,2155 @@
+@@ -1,3 +1,2166 @@
++2024-03-23  Harald Anlauf  <anlauf@gmx.de>
++
++	PR fortran/101135
++	* gfortran.dg/missing_optional_dummy_6a.f90: Adjust diagnostic pattern.
++	* gfortran.dg/ubsan/missing_optional_dummy_8.f90: New test.
++
++2024-03-23  Harald Anlauf  <anlauf@gmx.de>
++
++	PR fortran/55978
++	* gfortran.dg/null_actual_5.f90: New test.
++
 +2024-03-22  liuhongt  <hongtao.liu@intel.com>
 +
 +	Backported from master:
@@ -429104,15 +429194,18 @@ new file mode 100644
 +end program p
 --- a/src/gcc/testsuite/gfortran.dg/missing_optional_dummy_6a.f90
 +++ b/src/gcc/testsuite/gfortran.dg/missing_optional_dummy_6a.f90
-@@ -47,7 +47,7 @@ contains
+@@ -47,9 +47,9 @@ contains
  
  end program test
  
 -! { dg-final { scan-tree-dump-times "scalar2 \\(slr1" 1 "original" } }
 +! { dg-final { scan-tree-dump-times "scalar2 \\(.* slr1" 1 "original" } }
  
- ! { dg-final { scan-tree-dump-times "= es1 != 0B" 1 "original" } }
+-! { dg-final { scan-tree-dump-times "= es1 != 0B" 1 "original" } }
++! { dg-final { scan-tree-dump-times "= es1 != 0B" 2 "original" } }
  ! { dg-final { scan-tree-dump-times "assumed_shape2 \\(es1" 0 "original" } }
+ ! { dg-final { scan-tree-dump-times "explicit_shape2 \\(es1" 1 "original" } }
+ 
 --- a/src/gcc/testsuite/gfortran.dg/namelist_57.f90
 +++ b/src/gcc/testsuite/gfortran.dg/namelist_57.f90
 @@ -6,7 +6,7 @@
@@ -429176,6 +429269,86 @@ new file mode 100644
 +end
 new file mode 100644
 --- /dev/null
++++ b/src/gcc/testsuite/gfortran.dg/null_actual_5.f90
+@@ -0,0 +1,76 @@
++! { dg-do compile }
++! PR fortran/55978
++!
++! Passing of NULL() with and without MOLD as actual argument
++!
++! Testcase derived from pr55978 comment#16
++
++program pr55978_c16
++  implicit none
++
++  integer, pointer       :: p(:)
++  integer, allocatable   :: a(:)
++  character(10), pointer :: c
++  character(10), pointer :: cp(:)
++
++  type t
++    integer, pointer     :: p(:)
++    integer, allocatable :: a(:)
++  end type
++
++  type(t) :: d
++
++  ! (1) pointer
++  p => null()
++  call sub (p)
++
++  ! (2) allocatable
++  call sub (a)
++  call sub (d%a)
++
++  ! (3) pointer component
++  d%p => null ()
++  call sub (d%p)
++
++  ! (4) NULL
++  call sub (null (a))   ! OK
++  call sub (null (p))   ! OK
++  call sub (null (d%a)) ! OK
++  call sub (null (d%p)) ! OK
++  call sub (null ())    ! was erroneously rejected with:
++  ! Actual argument contains too few elements for dummy argument 'x' (1/4)
++
++  call bla (null(c))
++  call bla (null())     ! was erroneously rejected with:
++  ! Actual argument contains too few elements for dummy argument 'x' (1/10)
++
++  call foo (null(cp))
++  call foo (null())
++
++  call bar (null(cp))
++  call bar (null())     ! was erroneously rejected with:
++  ! Actual argument contains too few elements for dummy argument 'x' (1/70)
++
++contains
++
++  subroutine sub(x)
++    integer, intent(in), optional :: x(4)
++    if (present (x)) stop 1
++  end
++
++  subroutine bla(x)
++    character(len=10), intent(in), optional :: x
++    if (present (x)) stop 2
++  end
++
++  subroutine foo(x)
++    character(len=10), intent(in), optional :: x(:)
++    if (present (x)) stop 3
++  end
++
++  subroutine bar(x)
++    character(len=10), intent(in), optional :: x(7)
++    if (present (x)) stop 4
++  end
++
++end
+new file mode 100644
+--- /dev/null
 +++ b/src/gcc/testsuite/gfortran.dg/optional_deferred_char_1.f90
 @@ -0,0 +1,100 @@
 +! { dg-do run }
@@ -430351,6 +430524,118 @@ new file mode 100644
 +end program test_func_array
 new file mode 100644
 --- /dev/null
++++ b/src/gcc/testsuite/gfortran.dg/ubsan/missing_optional_dummy_8.f90
+@@ -0,0 +1,108 @@
++! { dg-do run }
++! { dg-additional-options "-fdump-tree-original -fsanitize=undefined" }
++!
++! PR fortran/101135 - Load of null pointer when passing absent
++! assumed-shape array argument for an optional dummy argument
++!
++! Based on testcase by Marcel Jacobse
++
++program main
++  implicit none
++  character(len=3) :: a(6) = ['abc', 'def', 'ghi', 'jlm', 'nop', 'qrs']
++  call as ()
++  call as (a(::2))
++  call as_c ()
++  call as_c (a(2::2))
++  call test_wrapper
++  call test_wrapper_c
++  call test_ar_wrapper
++  call test_ar_wrapper_c
++contains
++  subroutine as (xx)
++    character(len=*), optional, intent(in) :: xx(*)
++    if (.not. present (xx)) return
++    print *, xx(1:3)
++  end subroutine as
++
++  subroutine as_c (zz) bind(c)
++    character(len=*), optional, intent(in) :: zz(*)
++    if (.not. present (zz)) return
++    print *, zz(1:3)
++  end subroutine as_c
++
++  subroutine test_wrapper (x)
++    real, dimension(1), intent(out), optional :: x
++    call test (x)
++    call test1 (x)
++    call test_c (x)
++    call test1_c (x)
++  end subroutine test_wrapper
++
++  subroutine test_wrapper_c (w) bind(c)
++    real, dimension(1), intent(out), optional :: w
++    call test (w)
++    call test1 (w)
++    call test_c (w)
++    call test1_c (w)
++  end subroutine test_wrapper_c
++
++  subroutine test (y)
++    real, dimension(:), intent(out), optional :: y
++    if (present (y)) y=0.
++  end subroutine test
++
++  subroutine test_c (y) bind(c)
++    real, dimension(:), intent(out), optional :: y
++    if (present (y)) y=0.
++  end subroutine test_c
++
++  subroutine test1 (y)
++    real, dimension(1), intent(out), optional :: y
++    if (present (y)) y=0.
++  end subroutine test1
++
++  subroutine test1_c (y) bind(c)
++    real, dimension(1), intent(out), optional :: y
++    if (present (y)) y=0.
++  end subroutine test1_c
++
++  subroutine test_ar_wrapper (p, q, r)
++    real,               intent(out), optional :: p
++    real, dimension(1), intent(out), optional :: q
++    real, dimension(:), intent(out), optional :: r
++    call test_ar (p)
++    call test_ar (q)
++    call test_ar (r)
++    call test_ar_c (p)
++    call test_ar_c (q)
++    call test_ar_c (r)
++  end subroutine test_ar_wrapper
++
++  subroutine test_ar_wrapper_c (u, v, s) bind(c)
++    real,               intent(out), optional :: u
++    real, dimension(1), intent(out), optional :: v
++    real, dimension(:), intent(out), optional :: s
++    call test_ar (u)
++    call test_ar (v)
++!   call test_ar (s)    ! Disabled due to runtime segfault, see pr114355
++    call test_ar_c (u)
++    call test_ar_c (v)
++    call test_ar_c (s)
++  end subroutine test_ar_wrapper_c
++
++  subroutine test_ar (z)
++    real, dimension(..), intent(out), optional :: z
++  end subroutine test_ar
++
++  subroutine test_ar_c (z) bind(c)
++    real, dimension(..), intent(out), optional :: z
++  end subroutine test_ar_c
++end program
++
++! { dg-final { scan-tree-dump-times "data = v != 0B " 2 "original" } }
++! { dg-final { scan-tree-dump-times "data = w != 0B " 2 "original" } }
++! { dg-final { scan-tree-dump-times "data = q != 0B " 2 "original" } }
++! { dg-final { scan-tree-dump-times "data = x != 0B " 2 "original" } }
++! { dg-final { scan-tree-dump-times "data = xx.0 != 0B " 1 "original" } }
++! { dg-output " abcghinop(\n|\r\n|\r)" }"
++! { dg-output " defjlmqrs(\n|\r\n|\r)" }"
+new file mode 100644
+--- /dev/null
 +++ b/src/gcc/testsuite/gm2/cpp/fail/cpp-fail.exp
 @@ -0,0 +1,37 @@
 +# Expect driver script for GCC Regression Tests
diff -pruN 13.2.0-20/debian/patches/hurd-amd64.diff 13.2.0-21/debian/patches/hurd-amd64.diff
--- 13.2.0-20/debian/patches/hurd-amd64.diff	2024-01-23 20:59:29.000000000 +0000
+++ 13.2.0-21/debian/patches/hurd-amd64.diff	2024-03-24 13:49:13.000000000 +0000
@@ -27,11 +27,9 @@ Date:   Sat May 6 13:55:44 2023 +0200
             * config/i386/gnu.h: Use PIE_SPEC, add static-pie case.
             * config/i386/gnu64.h: Use PIE_SPEC, add static-pie case.
 
-diff --git a/src/gcc/config.gcc b/src/gcc/config.gcc
-index 3000379cafc..e62849c1230 100644
 --- a/src/gcc/config.gcc
 +++ b/src/gcc/config.gcc
-@@ -5973,6 +5973,9 @@ case ${target} in
+@@ -5828,6 +5828,9 @@ case ${target} in
  	visium-*-*)
  		target_cpu_default2="TARGET_CPU_$with_cpu"
  		;;
@@ -41,9 +39,6 @@ index 3000379cafc..e62849c1230 100644
  esac
  
  t=
-diff --git a/src/gcc/config/i386/t-gnu64 b/src/gcc/config/i386/t-gnu64
-new file mode 100644
-index 00000000000..23ee6823d65
 --- /dev/null
 +++ b/src/gcc/config/i386/t-gnu64
 @@ -0,0 +1,38 @@
@@ -85,13 +80,9 @@ index 00000000000..23ee6823d65
 +MULTILIB_OSDIRNAMES = m64=../lib64$(call if_multiarch,:x86_64-gnu)
 +MULTILIB_OSDIRNAMES+= m32=$(if $(wildcard $(shell echo $(SYSTEM_HEADER_DIR))/../../usr/lib32),../lib32,../lib)$(call if_multiarch,:i386-gnu)
 +MULTILIB_OSDIRNAMES+= mx32=../libx32$(call if_multiarch,:x86_64-gnux32)
-
-
-diff --git a/src/gcc/config/i386/gnu.h b/src/gcc/config/i386/gnu.h
-index 8dc6d9ee4e3..e776144f96c 100644
 --- a/src/gcc/config/i386/gnu.h
 +++ b/src/gcc/config/i386/gnu.h
-@@ -27,12 +27,12 @@ along with GCC.  If not, see <http://www.gnu.org/licenses/>.
+@@ -27,12 +27,12 @@ along with GCC.  If not, see <http://www
  #undef	STARTFILE_SPEC
  #if defined HAVE_LD_PIE
  #define STARTFILE_SPEC \
@@ -107,11 +98,9 @@ index 8dc6d9ee4e3..e776144f96c 100644
  #endif
  
  #ifdef TARGET_LIBC_PROVIDES_SSP
-diff --git a/src/gcc/config/i386/gnu64.h b/src/gcc/config/i386/gnu64.h
-index a411f0e802a..332372fa067 100644
 --- a/src/gcc/config/i386/gnu64.h
 +++ b/src/gcc/config/i386/gnu64.h
-@@ -31,10 +31,10 @@ along with GCC.  If not, see <http://www.gnu.org/licenses/>.
+@@ -31,10 +31,10 @@ along with GCC.  If not, see <http://www
  #undef	STARTFILE_SPEC
  #if defined HAVE_LD_PIE
  #define STARTFILE_SPEC \
diff -pruN 13.2.0-20/debian/patches/libsanitizer-no-crypt.diff 13.2.0-21/debian/patches/libsanitizer-no-crypt.diff
--- 13.2.0-20/debian/patches/libsanitizer-no-crypt.diff	2024-03-23 10:38:07.000000000 +0000
+++ 13.2.0-21/debian/patches/libsanitizer-no-crypt.diff	2024-03-24 13:49:13.000000000 +0000
@@ -34,7 +34,7 @@ Differential Revision: https://reviews.l
 
 --- a/src/libsanitizer/sanitizer_common/sanitizer_common_interceptors.inc
 +++ b/src/libsanitizer/sanitizer_common/sanitizer_common_interceptors.inc
-@@ -10187,41 +10187,6 @@ INTERCEPTOR(SSIZE_T, getrandom, void *buf, SIZE_T buflen, unsigned int flags) {
+@@ -10187,41 +10187,6 @@ INTERCEPTOR(SSIZE_T, getrandom, void *bu
  #define INIT_GETRANDOM
  #endif
  
@@ -76,7 +76,7 @@ Differential Revision: https://reviews.l
  #if SANITIZER_INTERCEPT_GETENTROPY
  INTERCEPTOR(int, getentropy, void *buf, SIZE_T buflen) {
    void *ctx;
-@@ -10772,8 +10737,6 @@ static void InitializeCommonInterceptors() {
+@@ -10772,8 +10737,6 @@ static void InitializeCommonInterceptors
    INIT_GETUSERSHELL;
    INIT_SL_INIT;
    INIT_GETRANDOM;
@@ -98,7 +98,7 @@ Differential Revision: https://reviews.l
    ((SI_LINUX && __GLIBC_PREREQ(2, 25)) || SI_FREEBSD)
 --- a/src/libsanitizer/sanitizer_common/sanitizer_platform_limits_posix.cpp
 +++ b/src/libsanitizer/sanitizer_common/sanitizer_platform_limits_posix.cpp
-@@ -176,10 +176,6 @@ typedef struct user_fpregs elf_fpregset_t;
+@@ -177,10 +177,6 @@ typedef struct user_fpregs elf_fpregset_
  #  include "sanitizer_platform_interceptors.h"
  #  include "sanitizer_platform_limits_posix.h"
  
@@ -109,7 +109,7 @@ Differential Revision: https://reviews.l
  namespace __sanitizer {
    unsigned struct_utsname_sz = sizeof(struct utsname);
    unsigned struct_stat_sz = sizeof(struct stat);
-@@ -283,10 +279,6 @@ namespace __sanitizer {
+@@ -284,10 +280,6 @@ namespace __sanitizer {
    unsigned struct_statvfs64_sz = sizeof(struct statvfs64);
  #endif // SANITIZER_LINUX && !SANITIZER_ANDROID
  
diff -pruN 13.2.0-20/debian/patches/musl-ssp.diff 13.2.0-21/debian/patches/musl-ssp.diff
--- 13.2.0-20/debian/patches/musl-ssp.diff	2024-01-23 20:59:29.000000000 +0000
+++ 13.2.0-21/debian/patches/musl-ssp.diff	2024-03-24 13:49:13.000000000 +0000
@@ -3,7 +3,7 @@ and https://www.openwall.com/lists/musl/
 
 --- a/src/gcc/gcc.cc
 +++ b/src/gcc/gcc.cc
-@@ -1062,8 +1062,15 @@ proper position among the other output f
+@@ -1085,8 +1085,15 @@ proper position among the other output f
  
  #ifndef LINK_SSP_SPEC
  #ifdef TARGET_LIBC_PROVIDES_SSP
diff -pruN 13.2.0-20/debian/patches/pr114065-proposed.diff 13.2.0-21/debian/patches/pr114065-proposed.diff
--- 13.2.0-20/debian/patches/pr114065-proposed.diff	2024-03-23 10:38:07.000000000 +0000
+++ 13.2.0-21/debian/patches/pr114065-proposed.diff	2024-03-24 11:38:51.000000000 +0000
@@ -2,15 +2,17 @@
 
 --- a/src/gcc/ada/Makefile.rtl
 +++ b/src/gcc/ada/Makefile.rtl
-@@ -2122,6 +2122,7 @@ ifeq ($(strip $(filter-out mips% linux%,$(target_cpu) $(target_os))),)
+@@ -2121,7 +2121,8 @@ ifeq ($(strip $(filter-out mips% linux%,
+   s-linux.ads<libgnarl/s-linux__mips.ads \
    s-osinte.adb<libgnarl/s-osinte__posix.adb \
    s-osinte.ads<libgnarl/s-osinte__linux.ads \
-   s-osprim.adb<libgnat/s-osprim__posix.adb \
+-  s-osprim.adb<libgnat/s-osprim__posix.adb \
++  s-osprim.adb<libgnat/s-osprim__posix2008.adb \
 +  s-parame.ads<libgnat/s-parame__posix2008.ads \
    s-taprop.adb<libgnarl/s-taprop__linux.adb \
    s-tasinf.ads<libgnarl/s-tasinf__linux.ads \
    s-tasinf.adb<libgnarl/s-tasinf__linux.adb \
-@@ -2165,6 +2166,7 @@ ifeq ($(strip $(filter-out powerpc% linux%,$(target_cpu) $(target_os))),)
+@@ -2165,10 +2166,11 @@ ifeq ($(strip $(filter-out powerpc% linu
    s-intman.adb<libgnarl/s-intman__posix.adb \
    s-linux.ads<libgnarl/s-linux.ads \
    s-osinte.adb<libgnarl/s-osinte__posix.adb \
@@ -18,34 +20,47 @@
    s-tpopsp.adb<libgnarl/s-tpopsp__tls.adb \
    s-mudido.adb<libgnarl/s-mudido__affinity.adb \
    s-osinte.ads<libgnarl/s-osinte__linux.ads \
-@@ -2214,6 +2216,7 @@ ifeq ($(strip $(filter-out arm% linux-gnueabi%,$(target_cpu) $(target_os))),)
+-  s-osprim.adb<libgnat/s-osprim__posix.adb \
++  s-osprim.adb<libgnat/s-osprim__posix2008.adb \
+   s-taprop.adb<libgnarl/s-taprop__linux.adb \
+   s-tasinf.ads<libgnarl/s-tasinf__linux.ads \
+   s-tasinf.adb<libgnarl/s-tasinf__linux.adb \
+@@ -2213,7 +2215,8 @@ ifeq ($(strip $(filter-out arm% linux-gn
+   s-linux.ads<libgnarl/s-linux.ads \
    s-osinte.adb<libgnarl/s-osinte__posix.adb \
    s-osinte.ads<libgnarl/s-osinte__linux.ads \
-   s-osprim.adb<libgnat/s-osprim__posix.adb \
+-  s-osprim.adb<libgnat/s-osprim__posix.adb \
++  s-osprim.adb<libgnat/s-osprim__posix2008.adb \
 +  s-parame.ads<libgnat/s-parame__posix2008.ads \
    s-taprop.adb<libgnarl/s-taprop__linux.adb \
    s-tasinf.ads<libgnarl/s-tasinf__linux.ads \
    s-tasinf.adb<libgnarl/s-tasinf__linux.adb \
-@@ -2325,6 +2328,7 @@ ifeq ($(strip $(filter-out hppa% linux%,$(target_cpu) $(target_os))),)
+@@ -2324,7 +2327,8 @@ ifeq ($(strip $(filter-out hppa% linux%,
+   s-linux.ads<libgnarl/s-linux__hppa.ads \
    s-osinte.adb<libgnarl/s-osinte__posix.adb \
    s-osinte.ads<libgnarl/s-osinte__linux.ads \
-   s-osprim.adb<libgnat/s-osprim__posix.adb \
+-  s-osprim.adb<libgnat/s-osprim__posix.adb \
++  s-osprim.adb<libgnat/s-osprim__posix2008.adb \
 +  s-parame.ads<libgnat/s-parame__posix2008.ads \
    s-taprop.adb<libgnarl/s-taprop__linux.adb \
    s-tasinf.ads<libgnarl/s-tasinf__linux.ads \
    s-tasinf.adb<libgnarl/s-tasinf__linux.adb \
-@@ -2352,6 +2356,7 @@ ifeq ($(strip $(filter-out m68k% linux%,$(target_cpu) $(target_os))),)
+@@ -2351,7 +2355,8 @@ ifeq ($(strip $(filter-out m68k% linux%,
+   s-linux.ads<libgnarl/s-linux.ads \
    s-osinte.adb<libgnarl/s-osinte__posix.adb \
    s-osinte.ads<libgnarl/s-osinte__linux.ads \
-   s-osprim.adb<libgnat/s-osprim__posix.adb \
+-  s-osprim.adb<libgnat/s-osprim__posix.adb \
++  s-osprim.adb<libgnat/s-osprim__posix2008.adb \
 +  s-parame.ads<libgnat/s-parame__posix2008.ads \
    s-taprop.adb<libgnarl/s-taprop__linux.adb \
    s-tasinf.ads<libgnarl/s-tasinf__linux.ads \
    s-tasinf.adb<libgnarl/s-tasinf__linux.adb \
-@@ -2379,6 +2384,7 @@ ifeq ($(strip $(filter-out sh4% linux%,$(target_cpu) $(target_os))),)
+@@ -2378,7 +2383,8 @@ ifeq ($(strip $(filter-out sh4% linux%,$
+   s-linux.ads<libgnarl/s-linux.ads \
    s-osinte.adb<libgnarl/s-osinte__posix.adb \
    s-osinte.ads<libgnarl/s-osinte__linux.ads \
-   s-osprim.adb<libgnat/s-osprim__posix.adb \
+-  s-osprim.adb<libgnat/s-osprim__posix.adb \
++  s-osprim.adb<libgnat/s-osprim__posix2008.adb \
 +  s-parame.ads<libgnat/s-parame__posix2008.ads \
    s-taprop.adb<libgnarl/s-taprop__linux.adb \
    s-tasinf.ads<libgnarl/s-tasinf__linux.ads \
diff -pruN 13.2.0-20/debian/patches/pr88552.diff 13.2.0-21/debian/patches/pr88552.diff
--- 13.2.0-20/debian/patches/pr88552.diff	2024-01-23 20:59:29.000000000 +0000
+++ 13.2.0-21/debian/patches/pr88552.diff	2024-03-24 13:49:13.000000000 +0000
@@ -23,7 +23,7 @@ gcc/testsuite/ChangeLog:
 
 --- a/src/gcc/fortran/decl.cc
 +++ b/src/gcc/fortran/decl.cc
-@@ -3366,6 +3366,7 @@ close_brackets:
+@@ -3383,6 +3383,7 @@ close_brackets:
        else
  	gfc_error ("Missing right parenthesis at %C");
        m = MATCH_ERROR;
@@ -31,7 +31,7 @@ gcc/testsuite/ChangeLog:
      }
    else
       /* All tests passed.  */
-@@ -4703,6 +4704,9 @@ get_kind:
+@@ -4720,6 +4721,9 @@ get_kind:
      }
  
    m = gfc_match_kind_spec (ts, false);
diff -pruN 13.2.0-20/debian/patches/rename-info-files.diff 13.2.0-21/debian/patches/rename-info-files.diff
--- 13.2.0-20/debian/patches/rename-info-files.diff	2024-01-23 20:59:29.000000000 +0000
+++ 13.2.0-21/debian/patches/rename-info-files.diff	2024-03-24 13:49:13.000000000 +0000
@@ -41,7 +41,7 @@ gcc/fortran/ChangeLog:
 --- a/src/gcc/fortran/Make-lang.in
 +++ b/src/gcc/fortran/Make-lang.in
 @@ -116,7 +116,9 @@ fortran.tags: force
- 	cd $(srcdir)/fortran; $(ETAGS) -o TAGS.sub *.c *.h; \
+ 	cd $(srcdir)/fortran; $(ETAGS) -o TAGS.sub *.cc *.h; \
  	$(ETAGS) --include TAGS.sub --include ../TAGS.sub
  
 -fortran.info: doc/gfortran.info doc/gfc-internals.info
@@ -93,7 +93,7 @@ gcc/fortran/ChangeLog:
  # Clean hooks:
 --- a/src/gcc/Makefile.in
 +++ b/src/gcc/Makefile.in
-@@ -3304,8 +3304,31 @@ install-no-fixedincludes:
+@@ -3335,8 +3335,31 @@ install-no-fixedincludes:
  
  doc: $(BUILD_INFO) $(GENERATED_MANPAGES)
  
@@ -127,7 +127,7 @@ gcc/fortran/ChangeLog:
  
  info: $(INFOFILES) lang.info @GENINSRC@ srcinfo lang.srcinfo
  
-@@ -3353,7 +3376,20 @@ gcc-vers.texi: $(BASEVER) $(DEVPHASE)
+@@ -3384,7 +3407,20 @@ gcc-vers.texi: $(BASEVER) $(DEVPHASE)
  	if [ -n "$(PKGVERSION)" ]; then \
  	  echo "@set VERSION_PACKAGE $(PKGVERSION)" >> $@T; \
  	fi
@@ -149,7 +149,7 @@ gcc/fortran/ChangeLog:
  	mv -f $@T $@
  
  
-@@ -3361,21 +3397,41 @@ gcc-vers.texi: $(BASEVER) $(DEVPHASE)
+@@ -3392,21 +3428,41 @@ gcc-vers.texi: $(BASEVER) $(DEVPHASE)
  # patterns.  To use them, put each of the specific targets with its
  # specific dependencies but no build commands.
  
@@ -198,7 +198,7 @@ gcc/fortran/ChangeLog:
  			-I $(gcc_docdir)/include -o $@ $<; \
  	fi
  
-@@ -3785,11 +3841,11 @@ install-driver: installdirs xgcc$(exeext
+@@ -3810,11 +3866,11 @@ install-driver: installdirs xgcc$(exeext
  # $(INSTALL_DATA) might be a relative pathname, so we can't cd into srcdir
  # to do the install.
  install-info:: doc installdirs \
@@ -215,7 +215,7 @@ gcc/fortran/ChangeLog:
  	lang.install-info
  
  $(DESTDIR)$(infodir)/%.info: doc/%.info installdirs
-@@ -4028,8 +4084,11 @@ uninstall: lang.uninstall
+@@ -4053,8 +4109,11 @@ uninstall: lang.uninstall
  	-rm -rf $(DESTDIR)$(bindir)/$(GCOV_INSTALL_NAME)$(exeext)
  	-rm -rf $(DESTDIR)$(man1dir)/$(GCC_INSTALL_NAME)$(man1ext)
  	-rm -rf $(DESTDIR)$(man1dir)/cpp$(man1ext)
@@ -239,7 +239,7 @@ gcc/fortran/ChangeLog:
 +* gnat-style: (gnat-style-13).      GNAT Coding Style
  @end direntry
  
- @definfoenclose strong,`,'
+ @c %**end of header
 --- a/src/gcc/ada/gnat_rm.texi
 +++ b/src/gcc/ada/gnat_rm.texi
 @@ -12,7 +12,7 @@
@@ -250,10 +250,10 @@ gcc/fortran/ChangeLog:
 +* GNAT Reference Manual: (gnat_rm-13).  Reference Manual for GNU Ada tools.
  @end direntry
  
- @definfoenclose strong,`,'
+ @c %**end of header
 --- a/src/gcc/doc/invoke.texi
 +++ b/src/gcc/doc/invoke.texi
-@@ -16647,7 +16647,7 @@ One of the standard libraries bypassed b
+@@ -17737,7 +17737,7 @@ One of the standard libraries bypassed b
  @option{-nodefaultlibs} is @file{libgcc.a}, a library of internal subroutines
  which GCC uses to overcome shortcomings of particular machines, or special
  needs for some languages.
@@ -262,7 +262,7 @@ gcc/fortran/ChangeLog:
  Collection (GCC) Internals},
  for more discussion of @file{libgcc.a}.)
  In most cases, you need @file{libgcc.a} even when you want to avoid
-@@ -16656,7 +16656,7 @@ or @option{-nodefaultlibs} you should us
+@@ -17746,7 +17746,7 @@ or @option{-nodefaultlibs} you should us
  This ensures that you have no unresolved references to internal GCC
  library subroutines.
  (An example of such an internal subroutine is @code{__main}, used to ensure C++
@@ -270,8 +270,8 @@ gcc/fortran/ChangeLog:
 +constructors are called; @pxref{Collect2,,@code{collect2}, @value{fngccint},
  GNU Compiler Collection (GCC) Internals}.)
  
- @item -e @var{entry}
-@@ -34111,7 +34111,7 @@ Note that you can also specify places to
+ @opindex nostdlib++
+@@ -35202,7 +35202,7 @@ Note that you can also specify places to
  @option{-B}, @option{-I} and @option{-L} (@pxref{Directory Options}).  These
  take precedence over places specified using environment variables, which
  in turn take precedence over those specified by the configuration of GCC@.
@@ -280,7 +280,7 @@ gcc/fortran/ChangeLog:
  GNU Compiler Collection (GCC) Internals}.
  
  @table @env
-@@ -34291,7 +34291,7 @@ the headers it contains change.
+@@ -35382,7 +35382,7 @@ the headers it contains change.
  
  A precompiled header file is searched for when @code{#include} is
  seen in the compilation.  As it searches for the included file
@@ -291,7 +291,7 @@ gcc/fortran/ChangeLog:
  the name specified in the @code{#include} with @samp{.gch} appended.  If
 --- a/src/gcc/doc/extend.texi
 +++ b/src/gcc/doc/extend.texi
-@@ -24503,7 +24503,7 @@ want to write code that checks whether t
+@@ -24639,7 +24639,7 @@ want to write code that checks whether t
  test for the GNU compiler the same way as for C programs: check for a
  predefined macro @code{__GNUC__}.  You can also use @code{__GNUG__} to
  test specifically for GNU C++ (@pxref{Common Predefined Macros,,
@@ -353,7 +353,7 @@ gcc/fortran/ChangeLog:
  
 --- a/src/gcc/doc/gcc.texi
 +++ b/src/gcc/doc/gcc.texi
-@@ -129,7 +129,7 @@ version @value{version-GCC}.
+@@ -135,7 +135,7 @@ version @value{version-GCC}.
  The internals of the GNU compilers, including how to port them to new
  targets and some information about how to write front ends for new
  languages, are documented in a separate manual.  @xref{Top,,
@@ -397,7 +397,7 @@ gcc/fortran/ChangeLog:
  This manual documents libgomp, the GNU Offloading and Multi Processing
 --- a/src/libgomp/Makefile.in
 +++ b/src/libgomp/Makefile.in
-@@ -610,7 +610,8 @@ info_TEXINFOS = libgomp.texi
+@@ -613,7 +613,8 @@ info_TEXINFOS = libgomp.texi
  
  # AM_CONDITIONAL on configure check ACX_CHECK_PROG_VER([MAKEINFO])
  @BUILD_INFO_TRUE@STAMP_BUILD_INFO = stamp-build-info
@@ -407,7 +407,7 @@ gcc/fortran/ChangeLog:
  MAINTAINERCLEANFILES = $(srcdir)/libgomp.info
  MULTISRCTOP = 
  MULTIBUILDTOP = 
-@@ -1390,15 +1391,16 @@ env.lo: libgomp_f.h
+@@ -1393,15 +1394,16 @@ env.lo: libgomp_f.h
  env.o: libgomp_f.h
  
  all-local: $(STAMP_GENINSRC)
@@ -431,7 +431,7 @@ gcc/fortran/ChangeLog:
  # target overrides
 --- a/src/libgomp/Makefile.am
 +++ b/src/libgomp/Makefile.am
-@@ -128,14 +128,16 @@ endif
+@@ -129,14 +129,16 @@ endif
  
  all-local: $(STAMP_GENINSRC)
  
diff -pruN 13.2.0-20/debian/patches/sys-auxv-header.diff 13.2.0-21/debian/patches/sys-auxv-header.diff
--- 13.2.0-20/debian/patches/sys-auxv-header.diff	2024-01-23 20:59:29.000000000 +0000
+++ 13.2.0-21/debian/patches/sys-auxv-header.diff	2024-03-24 13:49:13.000000000 +0000
@@ -1,7 +1,5 @@
 # DP: Check for the sys/auxv.h header file.
 
-Index: b/src/gcc/configure.ac
-===================================================================
 --- a/src/gcc/configure.ac
 +++ b/src/gcc/configure.ac
 @@ -1339,6 +1339,7 @@ AC_HEADER_TIOCGWINSZ
@@ -12,11 +10,9 @@ Index: b/src/gcc/configure.ac
  		 direct.h malloc.h langinfo.h ldfcn.h locale.h wchar.h)
  
  # Check for thread headers.
-Index: b/src/gcc/config.in
-===================================================================
 --- a/src/gcc/config.in
 +++ b/src/gcc/config.in
-@@ -1957,6 +1957,12 @@
+@@ -1975,6 +1975,12 @@
  #endif
  
  
@@ -29,8 +25,6 @@ Index: b/src/gcc/config.in
  /* Define to 1 if you have the <sys/file.h> header file. */
  #ifndef USED_FOR_TARGET
  #undef HAVE_SYS_FILE_H
-Index: b/src/gcc/config/rs6000/driver-rs6000.cc
-===================================================================
 --- a/src/gcc/config/rs6000/driver-rs6000.cc
 +++ b/src/gcc/config/rs6000/driver-rs6000.cc
 @@ -35,6 +35,10 @@ along with GCC; see the file COPYING3.
diff -pruN 13.2.0-20/debian/rules.parameters 13.2.0-21/debian/rules.parameters
--- 13.2.0-20/debian/rules.parameters	2024-03-23 10:38:07.000000000 +0000
+++ 13.2.0-21/debian/rules.parameters	2024-03-24 13:49:13.000000000 +0000
@@ -2,14 +2,14 @@
 GCC_VERSION	:= 13.2.0
 NEXT_GCC_VERSION	:= 13.2.1
 BASE_VERSION	:= 13
-SOURCE_VERSION	:= 13.2.0-20
-DEB_VERSION	:= 13.2.0-20
-DEB_EVERSION	:= 1:13.2.0-20
-DEB_GDC_VERSION	:= 13.2.0-20
+SOURCE_VERSION	:= 13.2.0-21
+DEB_VERSION	:= 13.2.0-21
+DEB_EVERSION	:= 1:13.2.0-21
+DEB_GDC_VERSION	:= 13.2.0-21
 DEB_SOVERSION	:= 5
 DEB_SOEVERSION	:= 1:5
 DEB_LIBGCC_SOVERSION	:= 
-DEB_LIBGCC_VERSION	:= 13.2.0-20
+DEB_LIBGCC_VERSION	:= 13.2.0-21
 DEB_STDCXX_SOVERSION	:= 5
 DEB_GOMP_SOVERSION	:= 5
 GCC_SONAME	:= 1
diff -pruN 13.2.0-20/debian/rules.patch 13.2.0-21/debian/rules.patch
--- 13.2.0-20/debian/rules.patch	2024-03-23 10:38:07.000000000 +0000
+++ 13.2.0-21/debian/rules.patch	2024-03-24 12:48:33.000000000 +0000
@@ -352,11 +352,15 @@ ifeq ($(with_ssp)-$(with_ssp_default),ye
 endif
 ifneq (,$(filter $(derivative),Ubuntu))
   ifneq (,$(filter $(distrelease),lucid precise trusty xenial bionic focal jammy kinetic lunar mantic))
-	echo '#define DIST_DEFAULT_FORTIFY_SOURCE 2' \
-	     >> $(srcdir)/gcc/distro-defaults.h
+	( \
+	  echo '#define DIST_DEFAULT_FORTIFY_SOURCE 2'; \
+	  echo '#define DIST_DEFAULT_FORTIFY_SOURCE_S "2"' \
+	) >> $(srcdir)/gcc/distro-defaults.h
   else
-	echo '#define DIST_DEFAULT_FORTIFY_SOURCE 3' \
-	     >> $(srcdir)/gcc/distro-defaults.h
+	( \
+	  echo '#define DIST_DEFAULT_FORTIFY_SOURCE 3'; \
+	  echo '#define DIST_DEFAULT_FORTIFY_SOURCE_S "3"' \
+	) >> $(srcdir)/gcc/distro-defaults.h
   endif
 	echo '#define DIST_DEFAULT_RELRO 1' \
 	     >> $(srcdir)/gcc/distro-defaults.h
